Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcco2_medusa.F90	(revision 5841)
@@ -47,5 +47,5 @@
 !=======================================================================
 !
-      SUBROUTINE trc_co2_medusa( Temp, Sal, DIC, ALK, Depth, Wnd, pCO2a, &
+      SUBROUTINE trc_co2_medusa( Temp, Sal, DIC, ALK, Depth, xkw, pCO2a, &
       pH, pCO2w, h2co3, hco3, co3, om_cal, om_arg, co2flux, TDIC, TALK,  &
       dcf, henry, iters )
@@ -72,4 +72,6 @@
 ! 17/02/2010. Update calculation of K1, K2, Kb to make consistant with the OCMIP protocols.
 ! 29/07/2011. Merged into MEDUSA with a raft of changes to this subroutine; less elsewhere
+! 23/06/2015. Modified to take gas transfer velocity as an input (rather than wind speed); 
+!             alter CO2 flux to /s rather than /d for consistency with other schemes
 !
 ! Changes for MEDUSA include: 
@@ -85,5 +87,6 @@
       REAL(wp), INTENT( in )    :: ALK        ! meq  / m3
       REAL(wp), INTENT( in )    :: Depth      ! m
-      REAL(wp), INTENT( in )    :: Wnd        ! m / s
+!     REAL(wp), INTENT( in )    :: Wnd        ! m / s
+      REAL(wp), INTENT( in )    :: xkw        ! m / s
       REAL(wp), INTENT( in )    :: pCO2a      ! uatm
 !----------------------------------------------------------------------
@@ -95,5 +98,5 @@
       REAL(wp), INTENT( inout ) :: om_cal     ! normalised
       REAL(wp), INTENT( inout ) :: om_arg     ! normalised
-      REAL(wp), INTENT( inout ) :: co2flux    ! mmol / m2 / d
+      REAL(wp), INTENT( inout ) :: co2flux    ! mmol / m2 / s
       REAL(wp), INTENT( inout ) :: TDIC       ! umol / kg
       REAL(wp), INTENT( inout ) :: TALK       ! ueq  / kg
@@ -129,5 +132,5 @@
    !                 (i.e. surface calculations being performed)
    if (Depth .eq. 0.0) then
-      call Air_sea_exchange( Temp, Wnd, pCO2w, pCO2a, henry, dcf, &         ! inputs
+      call Air_sea_exchange( Temp, xkw, pCO2w, pCO2a, henry, dcf, &         ! inputs
          co2flux )                                                          ! output
    else
@@ -145,5 +148,5 @@
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: zdic    =', DIC
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: zalk    =', ALK
-      IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_wind  =', Wnd
+      IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_kw660 =', xkw
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_ph    =', ph
       IF(lwp) WRITE(numout,*) ' trc_co2_medusa: f_pco2w =', pCO2w
@@ -162,5 +165,5 @@
       &        ' DIC', DIC, ' ALK', ALK
       if (lwp) write (numout,'(a,a,f10.3,a,f10.3)') 'CO2FLUX-NAN', &
-      &        ' WND', Wnd, ' PH ', ph
+      &        ' XKW', xkw, ' PH ', ph
       if (lwp) write (numout,'(a,a,i6)') 'CO2FLUX-NAN', &
       &        ' ITERS', iters
@@ -196,5 +199,5 @@
 !  WRITE(*,'(A27,F10.3)') "    Omega calcite       (~) = ", om_cal
 !  WRITE(*,'(A27,F10.3)') "    Omega aragonite     (~) = ", om_arg
-!  WRITE(*,'(A27,F10.3)') "    air sea flux(mmol/m2/d) = ", flux
+!  WRITE(*,'(A27,F10.3)') "    air sea flux(mmol/m2/s) = ", flux
 !  WRITE(*,*) " "
 
@@ -287,5 +290,5 @@
 !=======================================================================
 !
-      SUBROUTINE Air_sea_exchange( T, Wnd, pco2w, pco2a, henry, dcf, &
+      SUBROUTINE Air_sea_exchange( T, xkw, pco2w, pco2a, henry, dcf, &
       flux )
 !      
@@ -302,5 +305,6 @@
 !  pCO2a    partial pressure of CO2 in the atmosphere (usually external forcing).
 !  T        temperature (C)
-!  Wnd      wind speed, metres
+!  Wnd      wind speed, metres (DELETED)
+!  xkw      gas transfer velocity
 !  Henry    henry's constant
 !  density  the density of water for conversion between mmol/m3 and umol/kg
@@ -312,5 +316,5 @@
    IMPLICIT NONE
 
-      REAL(wp), INTENT( in )    :: T, wnd, pco2w, pco2a, henry, dcf ! INPUT PARAMETERS:
+      REAL(wp), INTENT( in )    :: T, xkw, pco2w, pco2a, henry, dcf ! INPUT PARAMETERS:
 !-----------------------------------------------------------------------
       REAL(wp), INTENT( inout ) :: flux                             ! OUTPUT Variables
@@ -320,5 +324,6 @@
 ! calculate the Schmidt number and unit conversions
           sc    = 2073.1-125.62*T+3.6276*T**2.0-0.0432190*T**3.0
-          fwind = (0.222d0 * wnd**2d0 + 0.333d0 * wnd)*(sc/660.d0)**(-0.5)
+!         fwind = (0.222d0 * wnd**2d0 + 0.333d0 * wnd)*(sc/660.d0)**(-0.5)
+          fwind = xkw * (sc/660.d0)**(-0.5)
           fwind = fwind*24.d0/100.d0   ! convert to m/day
 
@@ -326,4 +331,7 @@
 ! here it is rescaled to mmol/m2/d
           flux = fwind * henry * ( pco2a - pco2w ) * dcf
+
+! AXY (23/06/15): let's get it from /d to /s
+          flux = flux / ( 86400. )
 
   RETURN 
Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcdms_medusa.F90	(revision 5841)
@@ -39,5 +39,5 @@
 !
    SUBROUTINE trc_dms_medusa( chn, chd, mld, xqsr, xdin,   &  !! inputs
-     &  dms_surf, dms_andr, dms_simo, dms_aran, dms_hall )    !! outputs
+     &  dms_andr, dms_simo, dms_aran, dms_hall )              !! outputs
 !      
 !=======================================================================
@@ -70,4 +70,9 @@
       !!                    published (and different from the above)
       !!
+      !! AXY (08/07/15): amend to remove Julien's original calculation
+      !!                 as this is now superfluous; the four schemes 
+      !!                 are calculated and one is chosen to be passed
+      !!                 to the atmosphere in trc_bio_medusa
+      !!
 !=======================================================================
 
@@ -79,5 +84,4 @@
       REAL(wp), INTENT( in )    :: xqsr                 !! surface irradiance        (W/m2)
       REAL(wp), INTENT( in )    :: xdin                 !! surface DIN               (mmol N/m3)
-      REAL(wp), INTENT( inout ) :: dms_surf             !! DMS surface concentration (mol/m3) 
       REAL(wp), INTENT( inout ) :: dms_andr             !! DMS surface concentration (mol/m3) 
       REAL(wp), INTENT( inout ) :: dms_simo             !! DMS surface concentration (mol/m3) 
@@ -89,73 +93,4 @@
       !! temporary variables
       REAL(wp) ::    fq1,fq2,fq3
-!
-!! IJT (30/03/13): DMS calc needs this
-!! Julien : in Simo & Dachs, GBC, 2002, DMS is derived from 
-!!          CHL/MLD ratio in mg/m4 (i.e. CHL is in mg/m3
-!!          MLD in m).
-!!          In MEDUSA, we already have CHL in mg/m3 for both
-!!          Diatoms and non-diatoms (zchn,zchd); and mld from
-!!          NEMO (hmld) in m.
-      CHL = 0.0
-!!
-!!            CHL = mask * TT(I,J,1,PHYTO_TRACER) &
-!!     &       * c2n_p * mw_carbon / CCHL_P(I,J,1,1)
-      CHL = chn+chd                                 !! mg/m3 
-!!
-!! ------------------------------------------------
-!!  Calculate the DMS concentration in nM (nanomol/litre)
-!!   from Simo & Dachs, GBC, 2002, modified to be positive-definite
-!!   for MLD>182.536m, using DMS=90./MLD (Aranami & Tsunogai, JGR, 2004)
-!!   Multiply by 1.0E-6 to convert nM to (mol/m3)
-!!       cmr = fm(i,1)*chl/mld(i)
-!!       IF (cmr .lt. 0.02) THEN
-!!         IF (mld(i) .le. 182.536) THEN
-!!           csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(-LOG(mld(i)) + 5.7)
-!!         ELSE
-!!           csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(90./mld(i))
-!!         ENDIF
-!!       ELSE
-!!         csurf(i,astf_dms) = 1.0e-6*fm(i,1)*(55.8*cmr + 0.6)
-!!       ENDIF
-!!
-        cmr      = CHL / mld
-!       sw_dms   = 0.5 + SIGN( 0.5, cmr - 0.02 )
-!! Jpalm (11-08-2014)
-!! Explanation about the SIGN function :
-!! not easy to read, but maybe "more elegant and efficient")
-!! here for example: 
-!! sw_dms = 1 if cmr is greater than 0.02,
-!!          0 if cmr lower than 0.02
-!! then 
-!! if cmr < 0.02
-!!  dms_surf =  1.0e-6 * 90.0 / mld 
-!!       or  =  1.0e-6 * 5.7 - LOG(mld)
-!! and if cmr > 0.02
-!!  dms_surf = 1.0e-6 * ( 55.8 * cmr + 0.6 )
-!! what is equivalent to the IF loops formulations.
-!! difference is on the stresholds between mld = 182.536m
-!! (strange value...)
-!! and the Max function... that stay uncertain.
-!!
-!        dms_surf = 1.0e-6 * ( sw_dms *             &
-!     &  ( 55.8 * cmr + 0.6 ) + ( 1.0 - sw_dms ) *  &
-!     &  ( MAX( 90.0 / mld, 5.7 - LOG(mld) ) ) )
-!
-! AXY (12/01/15): the DMS equation donated by the UKMO does not match
-!                 that reported in Halloran et al. (2010); amend the
-!                 equations appropriately
-!
-        if (cmr .lt. 0.02) then
-           dms_surf = (-1.0 * log(mld)) + 5.7
-        else
-           dms_surf = (55.8 * cmr) + 0.6
-        endif
-!    
-        if (mld > 182.5) then
-           dms_surf = (90.0 / mld)
-        endif
-!     
-        dms_surf = 1.0e-6 * dms_surf
-
 ! 
 !=======================================================================
@@ -163,4 +98,8 @@
 ! AXY (13/03/15): per remarks above, the following calculations estimate
 !                 DMS using all of the schemes examined for UKESM1
+!
+      CHL = 0.0
+      CHL = chn+chd                                 !! mg/m3 
+      cmr = CHL / mld
 !
 ! AXY (13/03/15): Anderson et al. (2001)
@@ -180,5 +119,4 @@
 !
 ! AXY (13/03/15): Simo & Dachs (2002)
-        cmr = CHL / mld
         fq1 = (-1 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
@@ -191,5 +129,4 @@
 !           
 ! AXY (13/03/15): Aranami & Tsunogai (2004)
-        cmr = CHL / mld
         fq1 = 60.0 / mld
         fq2 = (55.8 * cmr) + 0.6
@@ -202,5 +139,4 @@
 !        
 ! AXY (13/03/15): Halloran et al. (2010)
-        cmr = CHL / mld
         fq1 = (-1 * log(mld)) + 5.7
         fq2 = (55.8 * cmr) + 0.6
Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcini_medusa.F90	(revision 5841)
@@ -38,5 +38,5 @@
    !! JPALM (14/09/15)
    LOGICAL, PUBLIC ::                  &
-      ln_ccd = .FALSE.
+      ln_ccd = .TRUE.
 
    INTEGER ::                          &
@@ -236,4 +236,28 @@
      
       !!----------------------------------------------------------------------
+      !! Averaged properties for DMS calculations (various units)
+      !!----------------------------------------------------------------------
+      !!     
+      !! these store temporally averaged properties for DMS calculations (AXY, 07/07/15)
+      zb_dms_chn(:,:)  = 0.0  !! CHN
+      zn_dms_chn(:,:)  = 0.0
+      za_dms_chn(:,:)  = 0.0
+      zb_dms_chd(:,:)  = 0.0  !! CHD
+      zn_dms_chd(:,:)  = 0.0
+      za_dms_chd(:,:)  = 0.0
+      zb_dms_mld(:,:)  = 0.0  !! MLD
+      zn_dms_mld(:,:)  = 0.0
+      za_dms_mld(:,:)  = 0.0
+      zb_dms_qsr(:,:)  = 0.0  !! QSR
+      zn_dms_qsr(:,:)  = 0.0
+      za_dms_qsr(:,:)  = 0.0
+      zb_dms_din(:,:)  = 0.0  !! DIN
+      zn_dms_din(:,:)  = 0.0
+      za_dms_din(:,:)  = 0.0
+      !!
+      IF(lwp) WRITE(numout,*) ' trc_ini_medusa: average fields for DMS initialised to zero'
+      IF(lwp) CALL flush(numout)
+
+      !!----------------------------------------------------------------------
       !! AXY (04/11/13): initialise fields previously done by trc_sed_medusa
       !!----------------------------------------------------------------------
Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 5841)
@@ -83,5 +83,5 @@
       &  xsdiss,                                              &
       &  vsed,xhr,                                            &
-      &  sedlam,sedlostpoc,jpkb,jdms
+      &  sedlam,sedlostpoc,jpkb,jdms,jdms_input,jdms_model
 #if defined key_roam
       NAMELIST/natroam/ xthetaphy,xthetazoo,xthetanit,        &
@@ -138,11 +138,11 @@
      IF( ( .NOT.lk_iomput .AND. ln_diatrc ) .OR. ( ln_diatrc .AND. lk_medusa ) ) THEN
          !
-         ! Namelist nampisdia
+         ! Namelist nammeddia
          ! -------------------
-         REWIND( numnatp_ref )              ! Namelist nampisdia in reference namelist : Pisces diagnostics
+         REWIND( numnatp_ref )              ! Namelist nammeddia in reference namelist : MEDUSA diagnostics
          READ  ( numnatp_ref, nammeddia, IOSTAT = ios, ERR = 901)
 901      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in reference namelist', lwp )
 
-         REWIND( numnatp_cfg )              ! Namelist nampisdia in configuration namelist : Pisces diagnostics
+         REWIND( numnatp_cfg )              ! Namelist nammeddia in configuration namelist : MEDUSA diagnostics
          READ  ( numnatp_cfg, nammeddia, IOSTAT = ios, ERR = 902 )
 902      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in configuration namelist', lwp )
@@ -338,4 +338,6 @@
       jpkb	  = 0.
       jdms        = 0
+      jdms_input  = 0
+      jdms_input  = 3
             
       !REWIND(numnatm)
@@ -343,11 +345,11 @@
          ! Namelist natbio
          ! -------------------
-         REWIND( numnatp_ref )              ! Namelist nampisdia in reference namelist : Pisces diagnostics
+         REWIND( numnatp_ref )              ! Namelist natbio in reference namelist : MEDUSA diagnostics
          READ  ( numnatp_ref, natbio, IOSTAT = ios, ERR = 903)
-903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in reference namelist', lwp )
-
-         REWIND( numnatp_cfg )              ! Namelist nampisdia in configuration namelist : Pisces diagnostics
+903      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natbio in reference namelist', lwp )
+
+         REWIND( numnatp_cfg )              ! Namelist natbio in configuration namelist : MEDUSA diagnostics
          READ  ( numnatp_cfg, natbio, IOSTAT = ios, ERR = 904 )
-904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in configuration namelist', lwp )
+904      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natbio in configuration namelist', lwp )
          IF(lwm) WRITE ( numonp, natbio )
 
@@ -488,8 +490,8 @@
 !! UKESM1 - new diagnostics  !! Jpalm
 !!       jdms        :  include dms diagnostics
-!!
-!!
-!!
-
+!!	 jdms_input  :  use instant (0) or diel-avg (1) inputs
+!!       jdms_model  :  choice of DMS model passed to atmosphere
+!!                      1 = ANDR, 2 = SIMO, 3 = ARAN, 4 = HALL
+!!
       IF(lwp) THEN
 !!
@@ -510,4 +512,18 @@
          &   ' key_axy_carbchem                                                       = INACTIVE'
 #endif        
+#if defined key_mocsy
+         WRITE(numout,*)     &
+         &   ' key_mocsy                                                              = ACTIVE'
+#else
+         WRITE(numout,*)     &
+         &   ' key_mocsy                                                              = INACTIVE'
+#endif        
+#if defined key_avgqsr_medusa
+         WRITE(numout,*)     &
+         &   ' key_avgqsr_medusa                                                      = ACTIVE'
+#else
+         WRITE(numout,*)     &
+         &   ' key_avgqsr_medusa                                                      = INACTIVE'
+#endif        
 #if defined key_bs_axy_zforce
          WRITE(numout,*)     &
@@ -544,4 +560,11 @@
          WRITE(numout,*)     &
          &   ' key_axy_pi_co2                                                         = INACTIVE'
+# endif
+# if defined key_debug_medusa
+         WRITE(numout,*)     &
+         &   ' key_debug_medusa                                                       = ACTIVE'
+#else
+         WRITE(numout,*)     &
+         &   ' key_debug_medusa                                                       = INACTIVE'
 # endif
          WRITE(numout,*) ' '
@@ -971,8 +994,28 @@
          &   ' Vert layer for diagnostic of vertical flux,                jpkp        = ', jpkb
 !!
-!! UKESM1 - new diagnostics  !! Jpalm
+!! UKESM1 - new diagnostics  !! Jpalm; AXY (08/07/15)
          WRITE(numout,*) '=== UKESM1-related parameters'
          WRITE(numout,*)     &
          &   ' include DMS diagnostic?,                                   jdms        = ', jdms
+         if (jdms_input .eq. 0) then
+            WRITE(numout,*)     &
+            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = instantaneous'
+         else
+            WRITE(numout,*)     &
+            &   ' use instant (0) or diel-avg (1) inputs,                    jdms_input  = diel-average'
+         endif
+	 if (jdms_model .eq. 1) then
+            WRITE(numout,*)     &
+            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Anderson et al. (2001)'
+	 elseif (jdms_model .eq. 2) then
+            WRITE(numout,*)     &
+            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Simo & Dachs (2002)'
+	 elseif (jdms_model .eq. 3) then
+            WRITE(numout,*)     &
+            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Aranami & Tsunogai (2004)'
+	 elseif (jdms_model .eq. 4) then
+            WRITE(numout,*)     &
+            &   ' choice of DMS model passed to atmosphere,                  jdms_model  = Halloran et al. (2010)'
+         endif
 !!
       ENDIF
@@ -1032,14 +1075,14 @@
 
       !READ(numnatm,natroam)
-         ! Namelist natbio
+         ! Namelist natroam
          ! -------------------
-         REWIND( numnatp_ref )              ! Namelist nampisdia in reference namelist : Pisces diagnostics
-         READ  ( numnatp_ref, natbio, IOSTAT = ios, ERR = 905)
-905      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in reference namelist', lwp )
-
-         REWIND( numnatp_cfg )              ! Namelist nampisdia in configuration namelist : Pisces diagnostics
-         READ  ( numnatp_cfg, natbio, IOSTAT = ios, ERR = 906 )
-906      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in configuration namelist', lwp )
-         IF(lwm) WRITE ( numonp, natbio )
+         REWIND( numnatp_ref )              ! Namelist natroam in reference namelist : MEDUSA diagnostics
+         READ  ( numnatp_ref, natroam, IOSTAT = ios, ERR = 905)
+905      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natroam in reference namelist', lwp )
+
+         REWIND( numnatp_cfg )              ! Namelist natroam in configuration namelist : MEDUSA diagnostics
+         READ  ( numnatp_cfg, natroam, IOSTAT = ios, ERR = 906 )
+906      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natroam in configuration namelist', lwp )
+         IF(lwm) WRITE ( numonp, natroam )
 
 !! ROAM carbon, alkalinity and oxygen cycle parameters
@@ -1086,11 +1129,11 @@
          ! Namelist natopt
          ! -------------------
-         REWIND( numnatp_ref )              ! Namelist nampisdia in reference namelist : Pisces diagnostics
+         REWIND( numnatp_ref )              ! Namelist natopt in reference namelist : MEDUSA diagnostics
          READ  ( numnatp_ref, natopt, IOSTAT = ios, ERR = 907)
-907      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in reference namelist', lwp )
-
-         REWIND( numnatp_cfg )              ! Namelist nampisdia in configuration namelist : Pisces diagnostics
+907      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natopt in reference namelist', lwp )
+
+         REWIND( numnatp_cfg )              ! Namelist natopt in configuration namelist : MEDUSA diagnostics
          READ  ( numnatp_cfg, natopt, IOSTAT = ios, ERR = 908 )
-908      IF( ios /= 0 ) CALL ctl_nam ( ios , 'nammeddia in configuration namelist', lwp )
+908      IF( ios /= 0 ) CALL ctl_nam ( ios , 'natopt in configuration namelist', lwp )
          IF(lwm) WRITE ( numonp, natopt )
 
Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcopt_medusa.F90	(revision 5841)
@@ -73,5 +73,22 @@
       ! determination of surface irradiance
       ! -----------------------------------
-      zpar0m (:,:)   = qsr   (:,:) * 0.43
+      ! AXY (23/07/15): the inclusion of empirical DMS calculations requires
+      !                 daily averages of a series of properties that are
+      !                 used as inputs; these include surface irradiance; 
+      !                 here, this is taken advantage of to allow MEDUSA to
+      !                 base its submarine light field on daily average
+      !                 rather than "instantaneous" irradiance; largely
+      !                 because MEDUSA was originally formulated to work
+      !                 with diel average irradiance rather than a diel
+      !                 cycle; using key_avgqsr_medusa activates this
+      !                 functionality, while its absence gives default
+      !                 MEDUSA (which is whatever is supplied by NEMO)
+# if defined key_avgqsr_medusa
+      ! surface irradiance input is rolling average irradiance
+      zpar0m (:,:)   = zn_dms_qsr(:,:) * 0.43
+# else      
+      ! surface irradiance input is   instantaneous irradiance
+      zpar0m (:,:)   =        qsr(:,:) * 0.43
+# endif
       ! AXY (22/08/14): when zpar0m = 0, zpar100 is also zero and calculating 
       !                 euphotic depth is not possible (cf. the Arctic Octopus); 
@@ -92,5 +109,4 @@
       zparr  (:,:,1) = 0.5 * zpar0m(:,:)
       zparg  (:,:,1) = 0.5 * zpar0m(:,:)
-
 
       ! determination of xpar
@@ -146,5 +162,4 @@
       ENDDO 
 
-
       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('opt')")
Index: /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcoxy_medusa.F90
===================================================================
--- /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcoxy_medusa.F90	(revision 5840)
+++ /branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcoxy_medusa.F90	(revision 5841)
@@ -34,5 +34,4 @@
 ! The following is a map of the subroutines contained within this module
 ! - trc_oxy_medusa
-!      - CALLS gas_transfer
 !      - CALLS oxy_schmidt
 !      - CALLS oxy_sato
@@ -42,6 +41,6 @@
 !=======================================================================
 !
-   SUBROUTINE trc_oxy_medusa( pt, ps, uwind, vwind, pp0, o2, dz, &  !! inputs
-      kw660, o2flux, o2sat )                                        !! outputs
+   SUBROUTINE trc_oxy_medusa( pt, ps, kw660, pp0, o2,  &  !! inputs
+      kwo2, o2flux, o2sat )                               !! outputs
 !      
 !=======================================================================
@@ -57,16 +56,18 @@
       !! number of oxygen) and oxy_sato.f (calculates oxygen saturation 
       !! concentration at 1 atm).
+      !!
+      !! AXY (23/06/15): revised to allow common gas transfer velocity
+      !!                 to be used for CO2 and O2; outputs of this
+      !!                 routine amended to mmol/m3 from mol/m3
       !! 
       !! Function inputs are (in order) : 
       !!     pt      temperature                     (degrees C)
       !!     ps      salinity                        (PSU)
-      !!     uwind   u-wind velocity                 (m/s)
-      !!     vwind   v-wind velocity                 (m/s)
+      !!     kw660   gas transfer velocity           (m/s)
       !!     pp0     surface pressure                (divided by 1 atm)
-      !!     o2      surface O2 concentration        (mol/m3)
-      !!     dz      surface layer thickness         (m)
-      !! (*) kw660   gas transfer velocity           (m/s)
-      !! (*) o2flux  exchange rate of oxygen         (mol/m3/s)
-      !! (+) o2sat   oxygen saturation concentration (mol/m3)
+      !!     o2      surface O2 concentration        (mmol/m3)
+      !! (+) kwo2    gas transfer velocity for O2    (m/s)
+      !! (*) o2flux  exchange rate of oxygen         (mmol/m2/s)
+      !! (+) o2sat   oxygen saturation concentration (mmol/m3)
       !! 
       !! Where (*) is the function output (note its units).  
@@ -78,16 +79,14 @@
       REAL(wp), INTENT( in )    :: pt
       REAL(wp), INTENT( in )    :: ps
-      REAL(wp), INTENT( in )    :: uwind
-      REAL(wp), INTENT( in )    :: vwind
+      REAL(wp), INTENT( in )    :: kw660
       REAL(wp), INTENT( in )    :: pp0
       REAL(wp), INTENT( in )    :: o2
-      REAL(wp), INTENT( in )    :: dz
-      REAL(wp), INTENT( inout ) :: kw660, o2flux, o2sat
-!
-      REAL(wp) :: scl_wind, kwo2, o2schmidt, o2sato
-!
-! Calculate gas transfer
-! 
-      call gas_transfer(uwind, vwind, scl_wind, kw660)
+      REAL(wp), INTENT( out )   :: kwo2, o2flux, o2sat
+!
+      REAL(wp) :: o2schmidt, o2sato, mol_o2
+!
+! Oxygen to mol / m3
+!
+      mol_o2 = o2 / 1000.
 !
 ! Calculate oxygen Schmidt number
@@ -106,5 +105,10 @@
 ! Calculate time rate of change of O2 due to gas exchange (mol/m3/s)
 !
-      o2flux = kwo2 * (o2sat - o2) / dz
+      o2flux = kwo2 * (o2sat - mol_o2)
+!
+! Oxygen flux and saturation to mmol / m3
+!
+      o2sat  =  o2sat * 1000.
+      o2flux = o2flux * 1000.
 !
       END SUBROUTINE trc_oxy_medusa
@@ -130,4 +134,12 @@
       !! are taken from Keeling et al. (1998, GBC, 12, 141-163).
       !! 
+      !! AXY (23/06/2015)
+      !! UPDATED: revised formulation from Wanninkhof (2014) for
+      !! consistency with MOCSY
+      !!
+      !! Winninkhof, R. (2014). Relationship between wind speed and gas
+      !! exchange over the ocean revisited. LIMNOLOGY AND OCEANOGRAPHY-METHODS
+      !! 12, 351-362, doi:10.4319/lom.2014.12.351
+      !!
       !! Function inputs are (in order) : 
       !!     t           temperature (degrees C)
@@ -141,12 +153,21 @@
 !
       REAL(wp) :: pt, o2_schmidt
-      REAL(wp) :: a0, a1, a2, a3
-!
-      data a0 /    1638.0 /
-      data a1 /    -81.83 /
-      data a2 /     1.483 /
-      data a3 / -0.008004 /
-!
-      o2_schmidt = a0 + pt*(a1 + pt*(a2 + pt*a3))
+      REAL(wp) :: a0, a1, a2, a3, a4
+!
+! AXY (23/06/15): OCMIP-2 coefficients
+!     data a0 /    1638.0 /
+!     data a1 /    -81.83 /
+!     data a2 /     1.483 /
+!     data a3 / -0.008004 /
+!
+! AXY (23/06/15): Wanninkhof (2014) coefficients
+      data a0 /     1920.4 /
+      data a1 /     -135.6 /
+      data a2 /     5.2121 /
+      data a3 /   -0.10939 /
+      data a4 / 0.00093777 /
+!
+!     o2_schmidt = a0 + pt*(a1 + pt*(a2 + pt*a3))
+      o2_schmidt = a0 + pt*(a1 + pt*(a2 + pt*(a3 + pt*a4)))
 !
       END SUBROUTINE oxy_schmidt
@@ -231,88 +252,4 @@
 !=======================================================================
 
-!=======================================================================
-!
-   SUBROUTINE gas_transfer( uwind, vwind, &  !! input 
-      scl_wind, k )                          !! output
-!      
-!=======================================================================
-      !!
-      !! Title  : Calculates gas transfer velocity
-      !! Author : Andrew Yool
-      !! Date   : 15/10/04 (revised 04/08/2011)
-      !! 
-      !! This subroutine uses near-surface wind speed to calculate gas
-      !! transfer velocity for use in CO2 and O2 exchange calculations.
-      !! 
-      !! Note that the parameterisation of Wanninkhof quoted here is a
-      !! truncation of the original equation.  It excludes a chemical
-      !! enhancement function (based on temperature), although such
-      !! temperature dependence is reported negligible by Etcheto &
-      !! Merlivat (1988).
-      !! 
-      !! Note also that in calculating scalar wind, the variance of the
-      !! wind over the period of a timestep is ignored.  Some authors,
-      !! for instance OCMIP-2, favour including some reference to the
-      !! variability of wind.  However, their wind fields are averaged
-      !! over relatively long time periods, and so this issue may be
-      !! safely (!) ignored here.
-      !! 
-      !! Subroutine inputs are (in order) :
-      !!     uwind     wind u velocity at 10 m (m/s)
-      !!     vwind     wind v velocity at 10 m (m/s)
-      !! (+) scl_wind  scalar wind velocity at 10 m (m/s)
-      !! (*) k         gas transfer velocity (m/s)
-      !! Where (*) is the function output and (+) is a diagnostic output.
-      !!
-!=======================================================================
-
-      implicit none
-!
-! Input variables
-      REAL(wp) :: uwind, vwind
-!
-! Output variables
-      REAL(wp) :: scl_wind, k, tmp_k
-!
-! Choice of parameterisation
-      INTEGER  :: eqn
-!
-! Coefficients for various parameterisations
-      REAL(wp), DIMENSION(6) :: a
-      REAL(wp), DIMENSION(6) :: b
-!
-! Values of coefficients
-      data a(1) / 0.166 /  ! Liss & Merlivat (1986)    [approximated]
-      data a(2) / 0.3   /  ! Wanninkhof (1992)         [sans enhancement]
-      data a(3) / 0.23  /  ! Nightingale et al. (2000) [good]
-      data a(4) / 0.23  /  ! Nightingale et al. (2000) [better]
-      data a(5) / 0.222 /  ! Nightingale et al. (2000) [best]
-      data a(6) / 0.337 /  ! OCMIP-2                   [sans variability]
-!
-      data b(1) / 0.133 /
-      data b(2) / 0.0   /
-      data b(3) / 0.0   /
-      data b(4) / 0.1   /
-      data b(5) / 0.333 /
-      data b(6) / 0.0   /
-!
-! Which parameterisation is to be used?
-      eqn = 2
-!
-! Calculate scalar wind (m/s)
-      scl_wind = (uwind**2 + vwind**2)**0.5
-!
-! Calculate gas transfer velocity (cm/h)
-      tmp_k = (a(eqn) * scl_wind**2) + (b(eqn) * scl_wind)
-!
-! Convert tmp_k from cm/h to m/s
-      k = tmp_k / (100. * 3600.)
-!
-      END SUBROUTINE gas_transfer
-
-!=======================================================================
-!=======================================================================
-!=======================================================================
-
 #else
    !!======================================================================
@@ -322,14 +259,14 @@
 CONTAINS
 
-   SUBROUTINE trc_oxy_medusa( pt, ps, uwind, vwind, pp0, o2, dz, &  !! inputs
-      kw660, o2flux, o2sat )                                        !! outputs
+   SUBROUTINE trc_oxy_medusa( pt, ps, kw660, pp0, o2,  &  !! inputs
+      o2flux, o2sat )                                     !! outputs
       USE par_kind
 
       REAL(wp), INTENT( in )    :: pt
       REAL(wp), INTENT( in )    :: ps
+      REAL(wp), INTENT( in )    :: kw660
       REAL(wp), INTENT( in )    :: pp0
       REAL(wp), INTENT( in )    :: o2
-      REAL(wp), INTENT( in )    :: dz
-      REAL(wp), INTENT( inout ) :: kw660, o2flux, o2sat
+      REAL(wp), INTENT( inout ) :: o2flux, o2sat
 
       WRITE(*,*) 'trc_oxy_medusa: You should not have seen this print! error?', kt
